package com.sun.jndi.toolkit.url;

import java.net.URLDecoder;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;

public final class UrlUtil
{
    private UrlUtil() {
    }
    
    public static final String decode(String s) throws MalformedURLException {
        try {
            return decode(s, "8859_1");
        }
        catch (UnsupportedEncodingException ex) {
            throw new MalformedURLException("ISO-Latin-1 decoder unavailable");
        }
    }
    
    public static final String decode(String s, String enc) throws MalformedURLException, UnsupportedEncodingException {
        try {
            return URLDecoder.decode(s, enc);
        }
        catch (IllegalArgumentException cause) {
            MalformedURLException ex = new MalformedURLException("Invalid URI encoding: " + s);
            ex.initCause(cause);
            throw ex;
        }
    }
    
    public static final String encode(String s, String charsetName) throws UnsupportedEncodingException {
        byte[] bytes = s.getBytes(charsetName);
        int length = bytes.length;
        char[] value = new char[3 * length];
        int count = 0;
        for (int i = 0; i < length; ++i) {
            if ((bytes[i] >= 97 && bytes[i] <= 122) || (bytes[i] >= 65 && bytes[i] <= 90) || (bytes[i] >= 48 && bytes[i] <= 57) || "=,+;.'-@&/$_()!~*:".indexOf((int)bytes[i]) >= 0) {
                value[count++] = (char)bytes[i];
            }
            else {
                value[count++] = '%';
                value[count++] = Character.forDigit(0xF & bytes[i] >>> 4, 16);
                value[count++] = Character.forDigit(0xF & bytes[i], 16);
            }
        }
        return new String(value, 0, count);
    }
}
